#define _POSIX_SOURCE 
/*-------------------------------------------------------------------*/
/*  Frv.c by B.Mours LAPP (Annecy)                                   */
/*-------------------------------------------------------------------*/

char FrvVersion[] = "2.0; Oct 12, 00";

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h> 
#include <stdarg.h>
#include <ctype.h>
#include "Frv.h"

/*-------------------------------------------------------FrvAdd ------*/
struct FrVect *FrvAdd(struct FrVect *vect1,
                      struct FrVect *vect2,
                      struct FrVect *vect3,
                      char *newName)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 int i;

 if(vect1 == NULL) return(NULL);
 if(vect2 == NULL) return(NULL);
 if(vect1->type  != vect2->type)  return(NULL);
 if(vect1->nData != vect2->nData) return(NULL);

 if(vect3 != NULL)
      {if(vect3->type  != vect1->type)  return(NULL);
       if(vect3->nData != vect1->nData) return(NULL);
       vect = vect3;}
 else {vect = FrvClone(vect1,newName);}

 if(vect->type == FR_VECT_C)
    {for(i=0; i<vect->nData; i++)
        {vect->data[i] = vect1->data[i] + vect2->data[i];}}
 else if(vect->type == FR_VECT_2S)
    {for(i=0; i<vect->nData; i++)
        {vect->dataS[i] = vect1->dataS[i] + vect2->dataS[i];}}
 else if(vect->type == FR_VECT_8R)
    {for(i=0; i<vect->nData; i++)
        {vect->dataD[i] = vect1->dataD[i] + vect2->dataD[i];}}
 else if(vect->type == FR_VECT_4R)
    {for(i=0; i<vect->nData; i++)
        {vect->dataF[i] = vect1->dataF[i] + vect2->dataF[i];}}
 else if(vect->type == FR_VECT_4S)
    {for(i=0; i<vect->nData; i++)
        {vect->dataI[i] = vect1->dataI[i] + vect2->dataI[i];}}
 else if(vect->type == FR_VECT_8S)
    {for(i=0; i<vect->nData; i++)
        {vect->dataL[i] = vect1->dataL[i] + vect2->dataL[i];}}
 else if(vect->type == FR_VECT_C8)
    {for(i=0; i<2*vect->nData; i++)
        {vect->dataF[i] = vect1->dataF[i] + vect2->dataF[i];}}
 else if(vect->type == FR_VECT_C16)
    {for(i=0; i<2*vect->nData; i++)
        {vect->dataD[i] = vect1->dataD[i] + vect2->dataD[i];}}
 else if(vect->type == FR_VECT_2U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataUS[i] = vect1->dataUS[i] + vect2->dataUS[i];}}
 else if(vect->type == FR_VECT_4U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataUI[i] = vect1->dataUI[i] + vect2->dataUI[i];}}
 else if(vect->type == FR_VECT_8U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataUL[i] = vect1->dataUL[i] + vect2->dataUL[i];}}
 else if(vect->type == FR_VECT_1U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataU[i] = vect1->dataU[i] + vect2->dataU[i];}}

 return(vect);
}/*----------------------------------------------------FrvCombine2----*/
struct FrVect *FrvCombine2(double s1,
                           struct FrVect *vect1,
                           double s2,
                           struct FrVect *vect2,
                           struct FrVect *vect3,
                           char *newName)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 int i;

 if(vect1 == NULL) return(NULL);
 if(vect2 == NULL) return(NULL);
 if(vect1->type  != vect2->type)  return(NULL);
 if(vect1->nData != vect2->nData) return(NULL);

 if(vect3 != NULL)
      {if(vect3->type  != vect1->type)  return(NULL);
       if(vect3->nData != vect1->nData) return(NULL);
       vect = vect3;}
 else {vect = FrvClone(vect1,newName);}

 if(vect->type == FR_VECT_C)
    {for(i=0; i<vect->nData; i++)
        {vect->data[i] = s1*vect1->data[i] + s2*vect2->data[i];}}
 else if(vect->type == FR_VECT_2S)
    {for(i=0; i<vect->nData; i++)
        {vect->dataS[i] = s1*vect1->dataS[i] + s2*vect2->dataS[i];}}
 else if(vect->type == FR_VECT_8R)
    {for(i=0; i<vect->nData; i++)
        {vect->dataD[i] = s1*vect1->dataD[i] + s2*vect2->dataD[i];}}
 else if(vect->type == FR_VECT_4R)
    {for(i=0; i<vect->nData; i++)
        {vect->dataF[i] = s1*vect1->dataF[i] + s2*vect2->dataF[i];}}
 else if(vect->type == FR_VECT_4S)
    {for(i=0; i<vect->nData; i++)
        {vect->dataI[i] = s1*vect1->dataI[i] + s2*vect2->dataI[i];}}
 else if(vect->type == FR_VECT_8S)
    {for(i=0; i<vect->nData; i++)
        {vect->dataL[i] = s1*vect1->dataL[i] + s2*vect2->dataL[i];}}
 else if(vect->type == FR_VECT_C8)
    {for(i=0; i<2*vect->nData; i++)
        {vect->dataF[i] = s1*vect1->dataF[i] + s2*vect2->dataF[i];}}
 else if(vect->type == FR_VECT_C16)
    {for(i=0; i<2*vect->nData; i++)
        {vect->dataD[i] = s1*vect1->dataD[i] + s2*vect2->dataD[i];}}
 else if(vect->type == FR_VECT_2U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataUS[i] = s1*vect1->dataUS[i] + s2*vect2->dataUS[i];}}
 else if(vect->type == FR_VECT_4U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataUI[i] = s1*vect1->dataUI[i] + s2*vect2->dataUI[i];}}
 else if(vect->type == FR_VECT_8U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataUL[i] = s1*vect1->dataUL[i] + s2*vect2->dataUL[i];}}
 else if(vect->type == FR_VECT_1U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataU[i] = s1*vect1->dataU[i] + s2*vect2->dataU[i];}}

 return(vect);
}
/*------------------------------------------------------FrvClone------*/
struct FrVect *FrvClone(struct FrVect *vectin,
                        char *newName)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 long i;

   vect = (struct FrVect *) calloc(1,sizeof(struct FrVect));
   if(vect == NULL)  
        {return(NULL);}
   else {vect->classe = FrVectDef();}

   if(newName != NULL)
        {if(FrStrCpy(&vect->name,      newName) == NULL) return(NULL);}
   else {if(FrStrCpy(&vect->name, vectin->name) == NULL) return(NULL);}

   vect->compress = 0;
   vect->type     = vectin->type;
   vect->nData    = vectin->nData;
   vect->nBytes   = vectin->nBytes;
   vect->nDim     = vectin->nDim;
   vect->nx     = malloc(vectin->nDim*sizeof(long));
   vect->unitX  = malloc(vectin->nDim*sizeof(char *));
   vect->startX = malloc(vectin->nDim*sizeof(double));
   vect->dx     = malloc(vectin->nDim*sizeof(double));
   if(vect->nx     == NULL || 
      vect->unitX  == NULL || 
      vect->startX == NULL || 
      vect->dx     == NULL) return(NULL);

   for(i=0; i<vectin->nDim; i++)
     {vect->nx[i]     = vectin->nx[i];
      vect->startX[i] = vectin->startX[i];
      vect->dx[i]     = vectin->dx[i];
      FrStrCpy(&vect->unitX[i], vectin->unitX[i]);
      if(vect->unitX[i] == NULL && vectin->unitX[i] != NULL) return(NULL);}


   FrStrCpy(&vect->unitY, vectin->unitY);

   vect->wSize = vectin->wSize;
   vect->size = vectin->size;
   vect->data = malloc(vectin->size*vectin->wSize);
   if(vect->data == NULL) 
      {FrError(3,"FrVectCopy","malloc failed");
       return(NULL);}

   FrVectMap(vect);

   vect->next = NULL;

   return(vect);
}

/*-------------------------------------------------------FrvCombine---*/
struct FrVect *FrvCombine(int nVect,
                           ...)
/*--------------------------------------------------------------------*/
{va_list ap;
 struct FrVect *vect, **vectIn;
 double *scale;
 long i;
 char *name;

 if(nVect == 0) return(NULL);

 vectIn = (struct FrVect **) malloc(nVect * sizeof(struct FrVect*));
 scale  = (double *)         malloc(nVect * sizeof(double));
 if(scale == NULL || vectIn == NULL) return(NULL);

             /*---------------- extract parameters -------------------*/

 va_start(ap, nVect);
 for(i=0; i<nVect; i++)
    {scale[i]  = va_arg(ap, double);
     vectIn[i] = va_arg(ap, struct FrVect*);}
 vect = va_arg(ap, struct FrVect*);
 name = va_arg(ap, char*);

             /*--------------- perform operations --------------------*/

 if(nVect == 1)
   {vect = FrvScale(scale[i], vectIn[i], vect, name);}
else
   {vect = FrvCombine2(scale[0], vectIn[0], scale[0], vectIn[0], vect, name);
    if(nVect > 2)
    for(i=2; i<nVect; i++)
       {vect = FrvCombine2(1., vect, scale[i], vectIn[i], vect, NULL);}}

             /*----------------- free local space----------------------*/

 free(vectIn);
 free(scale);

 return(vect);}


/*----------------------------------------------------FrvCopyToD------*/
struct FrVect *FrvCopyToD(struct FrVect *vIn,
                          char *newName)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 int i;

 if(vIn == NULL) return(NULL);

 vect = FrVectNew1D(vIn->name, FR_VECT_8R, vIn->nData, vIn->dx[0], 
                    vIn->unitX[0], vIn->unitY);
 if(vect == NULL) return(NULL);
  
 if(vIn->type == FR_VECT_8R)
    {memcpy(vect->dataD, vIn->dataD, vIn->nData*sizeof(double));}
 else if(vIn->type == FR_VECT_C)
    {for(i=0; i<vect->nData; i++)   {vect->dataD[i] = vIn->data[i];}}
 else if(vIn->type == FR_VECT_2S)
    {for(i=0; i<vect->nData; i++)   {vect->dataD[i] = vIn->dataS[i];}}
 else if(vIn->type == FR_VECT_8R)
    {for(i=0; i<vect->nData; i++)   {vect->dataD[i] = vIn->dataD[i];}}
 else if(vIn->type == FR_VECT_4R)
    {for(i=0; i<vect->nData; i++)   {vect->dataD[i] = vIn->dataF[i];}}
 else if(vIn->type == FR_VECT_4S)
    {for(i=0; i<vect->nData; i++)   {vect->dataD[i] = vIn->dataI[i];}}
 else if(vIn->type == FR_VECT_8S)
    {for(i=0; i<vect->nData; i++)   {vect->dataD[i] = vIn->dataL[i];}}
 else if(vIn->type == FR_VECT_C8)
    {for(i=0; i<2*vect->nData; i++) {vect->dataD[i] = vIn->dataF[i];}}
 else if(vIn->type == FR_VECT_2U)
    {for(i=0; i<vect->nData; i++)   {vect->dataD[i] = vIn->dataUS[i];}}
 else if(vIn->type == FR_VECT_4U)
    {for(i=0; i<vect->nData; i++)   {vect->dataD[i] = vIn->dataUI[i];}}
 else if(vIn->type == FR_VECT_8U)
    {for(i=0; i<vect->nData; i++)   {vect->dataD[i] = vIn->dataUL[i];}}
 else if(vIn->type == FR_VECT_1U)
    {for(i=0; i<vect->nData; i++)   {vect->dataD[i] = vIn->dataU[i];}}

 return(vect);
}
/*----------------------------------------------------FrvCopyToF------*/
struct FrVect *FrvCopyToF(struct FrVect *vIn,
                          char *newName)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 int i;

 if(vIn == NULL) return(NULL);

 vect = FrVectNew1D(vIn->name, FR_VECT_4R, vIn->nData, vIn->dx[0], 
                    vIn->unitX[0], vIn->unitY);
 if(vect == NULL) return(NULL);
  
 if(vIn->type == FR_VECT_4R)
    {memcpy(vect->dataF, vIn->dataF, vect->nData * sizeof(float));}
 else if(vIn->type == FR_VECT_C)
    {for(i=0; i<vect->nData; i++)   {vect->dataF[i] = vIn->data[i];}}
 else if(vIn->type == FR_VECT_2S)
    {for(i=0; i<vect->nData; i++)   {vect->dataF[i] = vIn->dataS[i];}}
 else if(vIn->type == FR_VECT_8R)
    {for(i=0; i<vect->nData; i++)   {vect->dataF[i] = vIn->dataD[i];}}
 else if(vIn->type == FR_VECT_4S)
    {for(i=0; i<vect->nData; i++)   {vect->dataF[i] = vIn->dataI[i];}}
 else if(vIn->type == FR_VECT_8S)
    {for(i=0; i<vect->nData; i++)   {vect->dataF[i] = vIn->dataL[i];}}
 else if(vIn->type == FR_VECT_C8)
    {for(i=0; i<2*vect->nData; i++) {vect->dataF[i] = vIn->dataF[i];}}
 else if(vIn->type == FR_VECT_C16)
    {for(i=0; i<2*vect->nData; i++) {vect->dataF[i] = vIn->dataD[i];}}
 else if(vIn->type == FR_VECT_2U)
    {for(i=0; i<vect->nData; i++)   {vect->dataF[i] = vIn->dataUS[i];}}
 else if(vIn->type == FR_VECT_4U)
    {for(i=0; i<vect->nData; i++)   {vect->dataF[i] = vIn->dataUI[i];}}
 else if(vIn->type == FR_VECT_8U)
    {for(i=0; i<vect->nData; i++)   {vect->dataF[i] = vIn->dataUL[i];}}
 else if(vIn->type == FR_VECT_1U)
    {for(i=0; i<vect->nData; i++)   {vect->dataF[i] = vIn->dataU[i];}}

 return(vect);
}
/*----------------------------------------------------FrvCopyToI------*/
struct FrVect *FrvCopyToI(struct FrVect *vIn,
                          char *newName)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 int i;

 if(vIn == NULL) return(NULL);

 vect = FrVectNew1D(vIn->name, FR_VECT_4S, vIn->nData, vIn->dx[0], 
                    vIn->unitX[0], vIn->unitY);
 if(vect == NULL) return(NULL);
  
 if(vIn->type == FR_VECT_4S)
    {memcpy(vect->data, vIn->data, vect->nData *sizeof(int));}
 else if(vIn->type == FR_VECT_C)
    {for(i=0; i<vect->nData; i++)   {vect->dataI[i] = vIn->data[i];}}
 else if(vIn->type == FR_VECT_2S)
    {for(i=0; i<vect->nData; i++)   {vect->dataI[i] = vIn->dataS[i];}}
 else if(vIn->type == FR_VECT_8R)
    {for(i=0; i<vect->nData; i++)   {vect->dataI[i] = vIn->dataD[i];}}
 else if(vIn->type == FR_VECT_4R)
    {for(i=0; i<vect->nData; i++)   {vect->dataI[i] = vIn->dataF[i];}}
 else if(vIn->type == FR_VECT_8S)
    {for(i=0; i<vect->nData; i++)   {vect->dataI[i] = vIn->dataL[i];}}
 else if(vIn->type == FR_VECT_C8)
    {for(i=0; i<2*vect->nData; i++) {vect->dataI[i] = vIn->dataF[i];}}
 else if(vIn->type == FR_VECT_C16)
    {for(i=0; i<2*vect->nData; i++) {vect->dataI[i] = vIn->dataD[i];}}
 else if(vIn->type == FR_VECT_2U)
    {for(i=0; i<vect->nData; i++)   {vect->dataI[i] = vIn->dataUS[i];}}
 else if(vIn->type == FR_VECT_4U)
    {for(i=0; i<vect->nData; i++)   {vect->dataI[i] = vIn->dataUI[i];}}
 else if(vIn->type == FR_VECT_8U)
    {for(i=0; i<vect->nData; i++)   {vect->dataI[i] = vIn->dataUL[i];}}
 else if(vIn->type == FR_VECT_1U)
    {for(i=0; i<vect->nData; i++)   {vect->dataI[i] = vIn->dataU[i];}}

 return(vect);
}
/*----------------------------------------------------FrvCopyToS------*/
struct FrVect *FrvCopyToS(struct FrVect *vIn,
                          char *newName)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 int i;

 if(vIn == NULL) return(NULL);

 vect = FrVectNew1D(vIn->name, FR_VECT_2S, vIn->nData, vIn->dx[0], 
                    vIn->unitX[0], vIn->unitY);
 if(vect == NULL) return(NULL);
  
 
 if(vIn->type == FR_VECT_2S)
    {memcpy(vect->dataS, vIn->dataS, vect->nData*sizeof(short));}
 else if(vIn->type == FR_VECT_C)
    {for(i=0; i<vect->nData; i++)   {vect->dataS[i] = vIn->data[i];}}
 else if(vIn->type == FR_VECT_8R)
    {for(i=0; i<vect->nData; i++)   {vect->dataS[i] = vIn->dataD[i];}}
 else if(vIn->type == FR_VECT_4R)
    {for(i=0; i<vect->nData; i++)   {vect->dataS[i] = vIn->dataF[i];}}
 else if(vIn->type == FR_VECT_4S)
    {for(i=0; i<vect->nData; i++)   {vect->dataS[i] = vIn->dataI[i];}}
 else if(vIn->type == FR_VECT_8S)
    {for(i=0; i<vect->nData; i++)   {vect->dataS[i] = vIn->dataL[i];}}
 else if(vIn->type == FR_VECT_C8)
    {for(i=0; i<2*vect->nData; i++) {vect->dataS[i] = vIn->dataF[i];}}
 else if(vIn->type == FR_VECT_C16)
    {for(i=0; i<2*vect->nData; i++) {vect->dataS[i] = vIn->dataD[i];}}
 else if(vIn->type == FR_VECT_2U)
    {for(i=0; i<vect->nData; i++)   {vect->dataS[i] = vIn->dataUS[i];}}
 else if(vIn->type == FR_VECT_4U)
    {for(i=0; i<vect->nData; i++)   {vect->dataS[i] = vIn->dataUI[i];}}
 else if(vIn->type == FR_VECT_8U)
    {for(i=0; i<vect->nData; i++)   {vect->dataS[i] = vIn->dataUL[i];}}
 else if(vIn->type == FR_VECT_1U)
    {for(i=0; i<vect->nData; i++)   {vect->dataS[i] = vIn->dataU[i];}}

 return(vect);
}
/*------------------------------------------------------FrvMult ------*/
struct FrVect *FrvMult(struct FrVect *vect1,
                       struct FrVect *vect2,
                       struct FrVect *vect3,
                       char *newName)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 int i;
 float tempF;
 double tempD;

 if(vect1 == NULL) return(NULL);
 if(vect2 == NULL) return(NULL);
 if(vect1->type  != vect2->type)  return(NULL);
 if(vect1->nData != vect2->nData) return(NULL);

 if(vect3 != NULL)
      {if(vect3->type  != vect1->type)  return(NULL);
       if(vect3->nData != vect1->nData) return(NULL);
       vect = vect3;}
 else {vect = FrvClone(vect1, newName);}

 if(vect->type == FR_VECT_C)
    {for(i=0; i<vect->nData; i++)
        {vect->data[i] = vect1->data[i] * vect2->data[i];}}
 else if(vect->type == FR_VECT_2S)
    {for(i=0; i<vect->nData; i++)
        {vect->dataS[i] = vect1->dataS[i] * vect2->dataS[i];}}
 else if(vect->type == FR_VECT_8R)
    {for(i=0; i<vect->nData; i++)
        {vect->dataD[i] = vect1->dataD[i] * vect2->dataD[i];}}
 else if(vect->type == FR_VECT_4R)
    {for(i=0; i<vect->nData; i++)
        {vect->dataF[i] = vect1->dataF[i] * vect2->dataF[i];}}
 else if(vect->type == FR_VECT_4S)
    {for(i=0; i<vect->nData; i++)
        {vect->dataI[i] = vect1->dataI[i] * vect2->dataI[i];}}
 else if(vect->type == FR_VECT_8S)
    {for(i=0; i<vect->nData; i++)
        {vect->dataL[i] = vect1->dataL[i] * vect2->dataL[i];}}
 else if(vect->type == FR_VECT_C8)
    {for(i=0; i<2*vect->nData; i=i+2)
        {tempF = vect1->dataF[i]   * vect2->dataF[i] -
                 vect1->dataF[i+1] * vect2->dataF[i+1];
         vect->dataF[i+1] = vect1->dataF[i]   * vect2->dataF[i+1] +
                            vect1->dataF[i+1] * vect2->dataF[i];
         vect->dataF[i] = tempF;}}
 else if(vect->type == FR_VECT_C16)
    {for(i=0; i<2*vect->nData; i=i+2)
        {tempD = vect1->dataD[i]   * vect2->dataD[i] -
                 vect1->dataD[i+1] * vect2->dataD[i+1];
         vect->dataD[i+1] = vect1->dataD[i]   * vect2->dataD[i+1] +
                            vect1->dataD[i+1] * vect2->dataD[i];
         vect->dataD[i] = tempD;}}
 else if(vect->type == FR_VECT_2U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataUS[i] = vect1->dataUS[i] * vect2->dataUS[i];}}
 else if(vect->type == FR_VECT_4U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataUI[i] = vect1->dataUI[i] * vect2->dataUI[i];}}
 else if(vect->type == FR_VECT_8U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataUL[i] = vect1->dataUL[i] * vect2->dataUL[i];}}
 else if(vect->type == FR_VECT_1U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataU[i] = vect1->dataU[i] * vect2->dataU[i];}}

 return(vect);
}
/*------------------------------------------------------FrvScale -----*/
struct FrVect *FrvScale(double scale,
                        struct FrVect *vect1,
                        struct FrVect *vect3,
                        char *newName)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 int i, scaleI;
 char   scaleC;
 short  scaleS;
 long   scaleL;
 float  scaleF;
 double scaleD;
 unsigned char  scaleU;
 unsigned short scaleUS;
 unsigned int   scaleUI;
 unsigned long  scaleUL;

 if(vect1 == NULL) return(NULL);

 if(vect3 != NULL)
      {if(vect3->type  != vect1->type)  return(NULL);
       if(vect3->nData != vect1->nData) return(NULL);
       vect = vect3;}
 else {vect = FrvClone(vect1,newName);}

 if(vect->type == FR_VECT_C)
    {scaleC = scale;
     for(i=0; i<vect->nData; i++) 
        {vect->data[i] = scale * vect1->data[i];}}
 else if(vect->type == FR_VECT_2S)
    {scaleS = scale;
     for(i=0; i<vect->nData; i++)
        {vect->dataS[i] = scaleS * vect1->dataS[i];}}
 else if(vect->type == FR_VECT_8R)
    {for(i=0; i<vect->nData; i++)
        {vect->dataD[i] = scale * vect1->dataD[i];}}
 else if(vect->type == FR_VECT_4R)
    {scaleF = scale;
     for(i=0; i<vect->nData; i++)
        {vect->dataF[i] = scaleF * vect1->dataF[i];}}
 else if(vect->type == FR_VECT_4S)
    {scaleI = scale;
     for(i=0; i<vect->nData; i++)
        {vect->dataI[i] = scaleI * vect1->dataI[i];}}
 else if(vect->type == FR_VECT_8S)
    {scaleL = scale;
     for(i=0; i<vect->nData; i++)
        {vect->dataL[i] = scaleL * vect1->dataL[i];}}
 else if(vect->type == FR_VECT_C8)
    {scaleF = scale;
     for(i=0; i<2*vect->nData; i++)
        {vect->dataF[i] = scaleF * vect1->dataF[i];}}
 else if(vect->type == FR_VECT_C16)
    {scaleD = scale;
     for(i=0; i<2*vect->nData; i++)
        {vect->dataD[i] = scaleD * vect1->dataD[i];}}
 else if(vect->type == FR_VECT_2U)
    {scaleUS = scale;
     for(i=0; i<vect->nData; i++)
        {vect->dataUS[i] = scaleUS * vect1->dataUS[i];}}
 else if(vect->type == FR_VECT_4U)
    {scaleUI = scale;
     for(i=0; i<vect->nData; i++)
        {vect->dataUI[i] = scaleUI * vect1->dataUI[i];}}
 else if(vect->type == FR_VECT_8U)
    {scaleUL = scale;
     for(i=0; i<vect->nData; i++)
        {vect->dataUL[i] = scaleUL * vect1->dataUL[i];}}
 else if(vect->type == FR_VECT_1U)
    {scaleU = scale;
     for(i=0; i<vect->nData; i++)
        {vect->dataU[i] = scaleU * vect1->dataU[i];}}

 return(vect);
}

/*-------------------------------------------------------FrvSub ------*/
struct FrVect *FrvSub(struct FrVect *vect1,
                      struct FrVect *vect2,
                      struct FrVect *vect3,
                      char *newName)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 int i;

 if(vect1 == NULL) return(NULL);
 if(vect2 == NULL) return(NULL);
 if(vect1->type  != vect2->type)  return(NULL);
 if(vect1->nData != vect2->nData) return(NULL);

 if(vect3 != NULL)
      {if(vect3->type  != vect1->type)  return(NULL);
       if(vect3->nData != vect1->nData) return(NULL);
       vect = vect3;}
 else {vect = FrvClone(vect1, newName);}

 if(vect->type == FR_VECT_C)
    {for(i=0; i<vect->nData; i++)
        {vect->data[i] = vect1->data[i] - vect2->data[i];}}
 else if(vect->type == FR_VECT_2S)
    {for(i=0; i<vect->nData; i++)
        {vect->dataS[i] = vect1->dataS[i] - vect2->dataS[i];}}
 else if(vect->type == FR_VECT_8R)
    {for(i=0; i<vect->nData; i++)
        {vect->dataD[i] = vect1->dataD[i] - vect2->dataD[i];}}
 else if(vect->type == FR_VECT_4R)
    {for(i=0; i<vect->nData; i++)
        {vect->dataF[i] = vect1->dataF[i] - vect2->dataF[i];}}
 else if(vect->type == FR_VECT_4S)
    {for(i=0; i<vect->nData; i++)
        {vect->dataI[i] = vect1->dataI[i] - vect2->dataI[i];}}
 else if(vect->type == FR_VECT_8S)
    {for(i=0; i<vect->nData; i++)
        {vect->dataL[i] = vect1->dataL[i] - vect2->dataL[i];}}
 else if(vect->type == FR_VECT_C8)
    {for(i=0; i<2*vect->nData; i++)
        {vect->dataF[i] = vect1->dataF[i] - vect2->dataF[i];}}
 else if(vect->type == FR_VECT_C16)
    {for(i=0; i<2*vect->nData; i++)
        {vect->dataD[i] = vect1->dataD[i] - vect2->dataD[i];}}
 else if(vect->type == FR_VECT_2U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataUS[i] = vect1->dataUS[i] - vect2->dataUS[i];}}
 else if(vect->type == FR_VECT_4U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataUI[i] = vect1->dataUI[i] - vect2->dataUI[i];}}
 else if(vect->type == FR_VECT_8U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataUL[i] = vect1->dataUL[i] - vect2->dataUL[i];}}
 else if(vect->type == FR_VECT_1U)
    {for(i=0; i<vect->nData; i++)
        {vect->dataU[i] = vect1->dataU[i] - vect2->dataU[i];}}

 return(vect);
}

/*-------------------------------------------------------FrvMean ------*/
int FrvMean(FrVect *vect, double *mean)
/*--------------------------------------------------------------------*/
{int i;
 double sum;

 if(vect == NULL)     return(0);
 if(vect->nData == 0) return(0);

 sum = 0.;
 if(vect->type == FR_VECT_C)
    {for(i=0; i<vect->nData; i++) {sum += vect->data[i];}}
 else if(vect->type == FR_VECT_2S)
    {for(i=0; i<vect->nData; i++) {sum += vect->dataS[i];}}
 else if(vect->type == FR_VECT_8R)
    {for(i=0; i<vect->nData; i++) {sum += vect->dataD[i];}}
 else if(vect->type == FR_VECT_4R)
    {for(i=0; i<vect->nData; i++) {sum += vect->dataF[i];}}
 else if(vect->type == FR_VECT_4S)
    {for(i=0; i<vect->nData; i++) {sum += vect->dataI[i];}}
 else if(vect->type == FR_VECT_8S)
    {for(i=0; i<vect->nData; i++) {sum += vect->dataL[i];}}
 else if(vect->type == FR_VECT_C8)
    {return(0);}
 else if(vect->type == FR_VECT_C16)
    {return(0);}
 else if(vect->type == FR_VECT_2U)
    {for(i=0; i<vect->nData; i++) {sum += vect->dataUS[i];}}
 else if(vect->type == FR_VECT_4U)
    {for(i=0; i<vect->nData; i++) {sum += vect->dataUI[i];}}
 else if(vect->type == FR_VECT_8U)
    {for(i=0; i<vect->nData; i++) {sum += vect->dataUL[i];}}
 else if(vect->type == FR_VECT_1U)
    {for(i=0; i<vect->nData; i++) {sum += vect->dataU[i];}}

 *mean = sum/vect->nData;

 return(1);}
/*-------------------------------------------------------FrvRms ------*/
int FrvRms(FrVect *vect, double *mean, double *rms)
/*--------------------------------------------------------------------*/
{int i;
 double sum, sum2, val, rms2;

 if(vect == NULL)     return(0);
 if(vect->nData == 0) return(0);

 sum  = 0.;
 sum2 = 0.;

 if(vect->type == FR_VECT_C)
    {for(i=0; i<vect->nData; i++) {val = vect->data[i];
                                   sum  += val;
                                   sum2 += val*val;}}
 else if(vect->type == FR_VECT_2S)
    {for(i=0; i<vect->nData; i++) {val = vect->dataS[i];
                                   sum  += val;
                                   sum2 += val*val;}}
 else if(vect->type == FR_VECT_8R)
    {for(i=0; i<vect->nData; i++) {val = vect->dataD[i];
                                   sum  += val;
                                   sum2 += val*val;}}
 else if(vect->type == FR_VECT_4R)
    {for(i=0; i<vect->nData; i++) {val = vect->dataF[i];
                                   sum  += val;
                                   sum2 += val*val;}}
 else if(vect->type == FR_VECT_4S)
    {for(i=0; i<vect->nData; i++) {val = vect->dataI[i];
                                   sum  += val;
                                   sum2 += val*val;}}
 else if(vect->type == FR_VECT_8S)
    {for(i=0; i<vect->nData; i++) {val = vect->dataL[i];
                                   sum  += val;
                                   sum2 += val*val;}}
 else if(vect->type == FR_VECT_C8)
    {return(0);}
 else if(vect->type == FR_VECT_C16)
    {return(0);}
 else if(vect->type == FR_VECT_2U)
    {for(i=0; i<vect->nData; i++) {val = vect->dataUS[i];
                                   sum  += val;
                                   sum2 += val*val;}}
 else if(vect->type == FR_VECT_4U)
    {for(i=0; i<vect->nData; i++) {val = vect->dataUI[i];
                                   sum  += val;
                                   sum2 += val*val;}}
 else if(vect->type == FR_VECT_8U)
    {for(i=0; i<vect->nData; i++) {val = vect->dataUL[i];
                                   sum  += val;
                                   sum2 += val*val;}}
 else if(vect->type == FR_VECT_1U)
    {for(i=0; i<vect->nData; i++) {val = vect->dataU[i];
                                   sum  += val;
                                   sum2 += val*val;}}

 *mean = sum/vect->nData;
 rms2 = sum2/vect->nData - (*mean)*(*mean);
 *rms = sqrt(rms2);

 return(0);}

/*-------------------------------------------------------FrvDelta ----*/
int FrvDelta(FrVect *vect, double *delta, double *previous)
/*--------------------------------------------------------------------*/
{int i;
 double prev, val, diff;

 if(vect == NULL)     return(0);
 if(vect->nData == 0) return(0);

 *delta= 0.;
 val = 0;

 if(vect->type == FR_VECT_C)
    {if(previous != NULL) 
          {prev = *previous;}
     else {prev = vect->data[0];}
     for(i=0; i<vect->nData; i++) {val = vect->data[i];
                                   diff = val - prev;
                                   if(diff < 0) diff = -diff;
				   if(diff > *delta) *delta = diff;
                                   prev = val;}}
 else if(vect->type == FR_VECT_2S)
    {if(previous != NULL) 
          {prev = *previous;}
     else {prev = vect->dataS[0];}
     for(i=0; i<vect->nData; i++) {val = vect->dataS[i];
                                   diff = val - prev;
                                   if(diff < 0) diff = -diff;
				   if(diff > *delta) *delta = diff;
                                   prev = val;}}
 else if(vect->type == FR_VECT_8R)
    {if(previous != NULL) 
          {prev = *previous;}
     else {prev = vect->dataD[0];}
     for(i=0; i<vect->nData; i++) {val = vect->dataD[i];
                                   diff = val - prev;
                                   if(diff < 0) diff = -diff;
				   if(diff > *delta) *delta = diff;
                                   prev = val;}}
 else if(vect->type == FR_VECT_4R)
    {if(previous != NULL) 
          {prev = *previous;}
     else {prev = vect->dataF[0];}
     for(i=0; i<vect->nData; i++) {val = vect->dataF[i];
                                   diff = val - prev;
                                   if(diff < 0) diff = -diff;
				   if(diff > *delta) *delta = diff;
                                   prev = val;}}
 else if(vect->type == FR_VECT_4S)
    {if(previous != NULL) 
          {prev = *previous;}
     else {prev = vect->dataI[0];}
     for(i=0; i<vect->nData; i++) {val = vect->dataI[i];
                                   diff = val - prev;
                                   if(diff < 0) diff = -diff;
				   if(diff > *delta) *delta = diff;
                                   prev = val;}}
 else if(vect->type == FR_VECT_8S)
    {if(previous != NULL) 
          {prev = *previous;}
     else {prev = vect->dataL[0];}
     for(i=0; i<vect->nData; i++) {val = vect->dataL[i];
                                   diff = val - prev;
                                   if(diff < 0) diff = -diff;
				   if(diff > *delta) *delta = diff;
                                   prev = val;}}
 else if(vect->type == FR_VECT_C8)
    {return(0);}
 else if(vect->type == FR_VECT_C16)
    {return(0);}
 else if(vect->type == FR_VECT_2U)
    {if(previous != NULL) 
          {prev = *previous;}
     else {prev = vect->dataUS[0];}
     for(i=0; i<vect->nData; i++) {val = vect->dataUS[i];
                                   diff = val - prev;
                                   if(diff < 0) diff = -diff;
				   if(diff > *delta) *delta = diff;
                                   prev = val;}}
 else if(vect->type == FR_VECT_4U)
    {if(previous != NULL) 
          {prev = *previous;}
     else {prev = vect->dataUI[0];}
     for(i=0; i<vect->nData; i++) {val = vect->dataUI[i];
                                   diff = val - prev;
                                   if(diff < 0) diff = -diff;
				   if(diff > *delta) *delta = diff;
                                   prev = val;}}
 else if(vect->type == FR_VECT_8U)
    {if(previous != NULL) 
          {prev = *previous;}
     else {prev = vect->dataUL[0];}
     for(i=0; i<vect->nData; i++) {val = vect->dataUL[i];
                                   diff = val - prev;
                                   if(diff < 0) diff = -diff;
				   if(diff > *delta) *delta = diff;
                                   prev = val;}}
 else if(vect->type == FR_VECT_1U)
    {if(previous != NULL) 
          {prev = *previous;}
     else {prev = vect->dataU[0];}
     for(i=0; i<vect->nData; i++) {val = vect->dataU[i];
                                   diff = val - prev;
                                   if(diff < 0) diff = -diff;
				   if(diff > *delta) *delta = diff;
                                   prev = val;}}
 else{return(2);}
    
 if(previous != NULL) *previous = val;

 return(0);}

/*------------------------------------------------------ FrvDecimate--*/
int FrvDecimate(FrVect *vect,
                int nGroup)
/*--------------------------------------------------------------------*/
{int i, j, off;
 double sum, coef;

 if(vect == NULL) return(1);
 if(nGroup <= 0) return(2);
 
 if(vect->nData % nGroup != 0) return(3);

 coef = 1./nGroup;

 vect->nData = vect->nData / nGroup;
 vect->dx[0] = vect->dx[0] * nGroup;
 vect->nBytes= vect->nBytes/ nGroup;

 off = 0;
 if(vect->type == FR_VECT_2S)
   {for(i=0; i < vect->nData; i++)
       {sum = 0.;
        for(j=off; j<off+nGroup; j++) {sum += vect->dataS[j];}
        vect->dataS[i] = sum*coef;
        off += nGroup;}}

 else if(vect->type == FR_VECT_4S)
   {for(i=0; i < vect->nData; i++)
       {sum = 0.;
        for(j=off; j<off+nGroup; j++) {sum += vect->dataI[j];}
        vect->dataI[i] = sum*coef;
        off += nGroup;}}
    
 else if(vect->type == FR_VECT_C)
   {for(i=0; i < vect->nData; i++)
       {sum = 0.;
        for(j=off; j<off+nGroup; j++) {sum += vect->data[j];}
        vect->data[i] = sum*coef;
        off += nGroup;}}
    
 else if(vect->type == FR_VECT_8R)
   {for(i=0; i < vect->nData; i++)
       {sum = 0.;
        for(j=off; j<off+nGroup; j++) {sum += vect->dataD[j];}
        vect->dataD[i] = sum*coef;
        off += nGroup;}}
    
 else if(vect->type == FR_VECT_4R)
   {for(i=0; i < vect->nData; i++)
       {sum = 0.;
        for(j=off; j<off+nGroup; j++) {sum += vect->dataF[j];}
        vect->dataF[i] = sum*coef;
        off += nGroup;}}
    
 else if(vect->type == FR_VECT_8S)
   {for(i=0; i < vect->nData; i++)
       {sum = 0.;
        for(j=off; j<off+nGroup; j++) {sum += vect->dataL[j];}
        vect->dataL[i] = sum*coef;
        off += nGroup;}}
    
 else if(vect->type == FR_VECT_2U)
   {for(i=0; i < vect->nData; i++)
       {sum = 0.;
        for(j=off; j<off+nGroup; j++) {sum += vect->dataUS[j];}
        vect->dataUS[i] = sum*coef;
        off += nGroup;}}
    
 else if(vect->type == FR_VECT_4U)
   {for(i=0; i < vect->nData; i++)
       {sum = 0.;
        for(j=off; j<off+nGroup; j++) {sum += vect->dataUI[j];}
        vect->dataUI[i] = sum*coef;
        off += nGroup;}}
    
 else if(vect->type == FR_VECT_8U)
   {for(i=0; i < vect->nData; i++)
       {sum = 0.;
        for(j=off; j<off+nGroup; j++) {sum += vect->dataUL[j];}
        vect->dataUL[i] = sum*coef;
        off += nGroup;}}
    
 return(1);}
