#ifndef MULTIFD_HH
#define MULTIFD_HH

#include "FDFilterBase.hh"
#include <vector>

class FSpectrum;
class FSeries;

class MultiFD : public FDFilterBase {
public:
   using FDFilterBase::Apply;

  MultiFD(void);
  MultiFD(const MultiFD& mfd);
  virtual ~MultiFD(void);
  virtual MultiFD& operator=(const MultiFD& mfd);
  virtual MultiFD* clone(void) const;
  virtual void     Apply(const FSeries& fin, FSeries& fout);
  virtual void     Apply(const FSpectrum& fin, FSpectrum& fout);
  void addFilter(const FDFilterBase& fdf);
private:
  void delete_filters(void);

private:
  typedef std::vector<FDFilterBase*> filter_vect;
  typedef filter_vect::iterator filter_iter;
  typedef filter_vect::const_iterator const_filter_iter;

  filter_vect mFilter;
};

#endif  // MULTIFD_HH
